"use strict";

var _chai = require("chai");

var _mocha = require("mocha");

var _graphql = require("graphql");

var _mergeAst = require("../mergeAst");

var _mergeAstFixture = require("./mergeAst-fixture");

/**
 *  Copyright (c) Facebook, Inc. and its affiliates.
 *
 *  This source code is licensed under the MIT license found in the
 *  LICENSE file in the root directory of this source tree.
 */
(0, _mocha.describe)('MergeAst', function () {
  _mergeAstFixture.fixtures.forEach(function (fixture) {
    (0, _mocha.it)(fixture.desc, function () {
      var result = (0, _graphql.print)((0, _mergeAst.mergeAst)((0, _graphql.parse)(fixture.query))).replace(/\s/g, '');
      (0, _chai.expect)(result).to.equal(fixture.mergedQuery.replace(/\s/g, ''));
    });
  });
});